import { world, GameMode } from '@minecraft/server';


const elevatorCamouflage = [
    { id: "minecraft:cobblestone",blockPerm: "op:camouflage" ,state: 1 },
    { id: "minecraft:stone", blockPerm: "op:camouflage" ,state: 2 },
    { id: "minecraft:dirt", blockPerm: "op:camouflage" ,state: 3 },
    { id: "minecraft:grass_block", blockPerm: "op:camouflage" ,state: 4 },
    { id: "minecraft:glass", blockPerm: "op:camouflage" ,state: 5 },
    { id: "minecraft:deepslate", blockPerm: "op:camouflage" ,state: 6 },
    { id: "minecraft:oak_planks", blockPerm: "op:camouflage" ,state: 7 },
    { id: "minecraft:sand", blockPerm: "op:camouflage" ,state: 8 },
    { id: "minecraft:barrel", blockPerm: "op:camouflage" ,state: 9 },
    { id: "minecraft:cobbled_deepslate", blockPerm: "op:camouflage" ,state: 10 },
    { id: "minecraft:netherrack", blockPerm: "op:camouflage" ,state: 11 },
    { id: "minecraft:white_concrete", blockPerm: "op:camouflage" ,state: 12 },
    { id: "minecraft:bamboo_planks", blockPerm: "op:camouflage" ,state: 13 },
    { id: "minecraft:bamboo_mosaic", blockPerm: "op:camouflage" ,state: 14 },
    { id: "minecraft:cherry_planks", blockPerm: "op:camouflage" ,state: 15 },
    { id: "minecraft:warped_planks",blockPerm: "op:camouflage2" ,state: 1 },
    { id: "minecraft:crimson_planks", blockPerm: "op:camouflage2" ,state: 2 },
    { id: "minecraft:mangrove_planks", blockPerm: "op:camouflage2" ,state: 3 },
    { id: "minecraft:obsidian", blockPerm: "op:camouflage2" ,state: 4 },
    { id: "minecraft:smooth_stone", blockPerm: "op:camouflage2" ,state: 5 },
    { id: "minecraft:quartz_block", blockPerm: "op:camouflage2" ,state: 6 },
    { id: "minecraft:brick_block", blockPerm: "op:camouflage2" ,state: 7 },
    { id: "minecraft:nether_brick", blockPerm: "op:camouflage2" ,state: 8 },
    { id: "minecraft:snow", blockPerm: "op:camouflage2" ,state: 9 },
    { id: "minecraft:moss_block", blockPerm: "op:camouflage2" ,state: 10 },
    { id: "minecraft:spruce_planks", blockPerm: "op:camouflage2" ,state: 11 },
    { id: "minecraft:birch_planks", blockPerm: "op:camouflage2" ,state: 12 },
    { id: "minecraft:jungle_planks", blockPerm: "op:camouflage2" ,state: 13 },
    { id: "minecraft:acacia_planks", blockPerm: "op:camouflage2" ,state: 14 },
    { id: "minecraft:dark_oak_planks", blockPerm: "op:camouflage2" ,state: 15 },
];

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockTypeRegistry.registerCustomComponent('elevatorid:camouflage', {
        onPlayerInteract: e => {
            const { block, player } = e;

            const item = player.getComponent('inventory').container.getItem(player.selectedSlotIndex);

            if (!item) {
                return;
            }

            const camouflageData = elevatorCamouflage.find(blockid => blockid.id === item.typeId);

            if (!camouflageData) {
                return;
            }

            player.playSound('block.camouflage');
            block.setPermutation(block.permutation.withState(camouflageData.blockPerm,camouflageData.state));
            
            if (player.matches({ gameMode: GameMode.survival })) {
                player.dimension.runCommandAsync(`clear @p ${item.typeId} 0 1`);
            }


        }
    });
});
