import { ItemStack, world, GameMode } from '@minecraft/server';

const elevatorCamouflage = [
    { id: "minecraft:cobblestone", state: 1 },
    { id: "minecraft:stone", state: 2 },
    { id: "minecraft:dirt", state: 3 },
    { id: "minecraft:grass_block", state: 4 },
    { id: "minecraft:glass", state: 5 },
    { id: "minecraft:deepslate", state: 6 },
    { id: "minecraft:oak_planks", state: 7 },
    { id: "minecraft:sand", state: 8 },
    { id: "minecraft:barrel", state: 9 },
    { id: "minecraft:cobbled_deepslate", state: 10 },
    { id: "minecraft:netherrack", state: 11 },
    { id: "minecraft:white_concrete", state: 12 },
    { id: "minecraft:bamboo_planks", state: 13 },
    { id: "minecraft:bamboo_mosaic", state: 14 },
    { id: "minecraft:cherry_planks", state: 15 },
];

const elevatorCamouflage2 = [
    { id: "minecraft:warped_planks", state: 1 },
    { id: "minecraft:crimson_planks", state: 2 },
    { id: "minecraft:mangrove_planks", state: 3 },
    { id: "minecraft:obsidian", state: 4 },
    { id: "minecraft:smooth_stone", state: 5 },
    { id: "minecraft:quartz_block", state: 6 },
    { id: "minecraft:brick_block", state: 7 },
    { id: "minecraft:nether_brick", state: 8 },
    { id: "minecraft:snow", state: 9 },
    { id: "minecraft:moss_block", state: 10 },
    { id: "minecraft:spruce_planks", state: 11 },
    { id: "minecraft:birch_planks", state: 12 },
    { id: "minecraft:jungle_planks", state: 13 },
    { id: "minecraft:acacia_planks", state: 14 },
    { id: "minecraft:dark_oak_planks", state: 15 },
];

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockTypeRegistry.registerCustomComponent('elevatorid:decamouflage', {
        onPlayerInteract: e => {
    
            const { block, player } = e;
    
            if (!player.isSneaking){
                return
            }
            if(block.permutation.getState("op:camouflage") === 0 && block.permutation.getState("op:camouflage2") === 0){
                return
            }
            let numberState = 1;
            let nameState = "op:camouflage";
            let camouflageData = elevatorCamouflage.find(blockid => blockid.state === block.permutation.getState(nameState));
            if (block.permutation.getState("op:camouflage2") !== 0){
                nameState = "op:camouflage2";
                numberState = 2;
                camouflageData = elevatorCamouflage2.find(blockid => blockid.state === block.permutation.getState(nameState));
            }
    
            if (!camouflageData) {
                return;
            }
    
            player.playSound('block.camouflage');
            block.setPermutation(block.permutation.withState(nameState,0));
            if (player.matches({ gameMode: GameMode.survival })) {
                player.getComponent('inventory').container.addItem(new ItemStack(camouflageData.id, 1));
            }
            
    
    
        }
    })
})
