import { world } from '@minecraft/server'
import { ModalFormData } from '@minecraft/server-ui'


export function directionalForm(player,block){
    const previousDirection = block.permutation.getState('op:directional')
    let defaultDirection = 0
    if (previousDirection == "north"){
        defaultDirection = 1
    }
    else if(previousDirection == "south"){
        defaultDirection = 2
    }
    else if(previousDirection == "west"){
        defaultDirection = 3
    }
    else if(previousDirection == "east"){
        defaultDirection = 4
    }
    const previousToggle = block.permutation.getState('op:hidearrow')
    let defaultToggle = false
    if (previousToggle == "true"){
        defaultToggle = true
    }
    const directions = ["None", "North", "South", "West", "East"]
    const dform = new ModalFormData()
        .title("Elevator Options")
        .dropdown("Directional", directions,defaultDirection)
        .toggle("Hide arrow", defaultToggle)
    dform.show(player).then((response) => {
        if (response.canceled) return;
        let [directional, toggle] = response.formValues
        if (directional === 0) {
            player.sendMessage('Directional Disabled');
            block.setPermutation(block.permutation.withState("op:directional","none"));
        } 
        else if(directional === 1){
            block.setPermutation(block.permutation.withState("op:directional","north"));
        }
        else if(directional === 2){
            block.setPermutation(block.permutation.withState("op:directional","south"));
        }
        else if(directional === 3){
            block.setPermutation(block.permutation.withState("op:directional","west"));
        }
        else if(directional === 4){
            block.setPermutation(block.permutation.withState("op:directional","east"));
        }
        if(toggle == true){
            block.setPermutation(block.permutation.withState("op:hidearrow","true"));
        }
        else{
            block.setPermutation(block.permutation.withState("op:hidearrow","false"));
        }
    })
}


world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockTypeRegistry.registerCustomComponent("op:directional", {
        onPlayerInteract: e => {
            const { block, player } = e;

            const item = player.getComponent('inventory').container.getItem(player.selectedSlotIndex);

            if (player.isSneaking){
                return
            }

            if (item) {
                return;
            }

            directionalForm(player,block)

        }
    });
});