export class BlockStateBuilder {
    #stateData;
    stateNames = [];
    values = [];

    constructor(stateData) {
        this.#stateData = stateData;
        for (const state of stateData) {
            this.stateNames.push(state[0]);
            this.values.push(state[1][0]);
        };
    }

    getStateRecord() {
        const record = {};
        for (let i = 0; i < this.#stateData.length; i++) {
            record[this.stateNames[i]] = arguments[i] === undefined ? this.values[i] : arguments[i];
        };
        return record;
    }

    getStateNames() {
        return this.stateNames;
    }

    getValue(stateName) {
        return this.#stateData.filter(state => state[0] === stateName)[0][1];
    }

    getAllValues() {
        const valueSet = [];
        for (const state of this.#stateData) {
            valueSet.push(state[1]);
        };
        return valueSet;
    }

    getDefaultValue(stateName) {
        return this.getValue(stateName)[0];
    }

    getAllDefaultValues() {
        const valueSet = [];
        for (const value of this.getAllValues()) {
            valueSet.push(value[0])
        };
        return valueSet;
    }
}