import { world, BlockPermutation } from "@minecraft/server";
import { Utils } from "./systemUtils";
import { BlockStateBuilder } from "../build/blockStateBuilder";

export class BlockUtils {
    static getBlock(dim, loc) {
        return world.getDimension(dim).getBlock(loc);
    }

    static getAimBlock(dim, loc, face) {
        return this.getBlock(dim, Utils.aimLoc(loc, face));
    }

    static setBlock(dim, loc, blockId, states = {}) {
        const blockPerm = BlockPermutation.resolve(blockId, states);
        this.getBlock(dim, loc).setPermutation(blockPerm);
    }

    static setState(block, stateName, stateValue) {
        block.setPermutation(block.permutation.withState(stateName, stateValue));
    }

    static setStates(block, states = {}) {
        for (const stateName in states) {
            this.setState(block, stateName, states[stateName]);
        };
    }
    static createStateRecord(stateData) {
        const record = new BlockStateBuilder(stateData);
        const values = Array.from(arguments);
        values.shift();
        return record.getStateRecord(...values);
    }
}