export class ItemStackUtils {
    static damageDurability(slot, damage = 1, ignoreUnbreakingEnchantment = false) {
        const itemStack = slot.getItem();
        if (!itemStack) {
            return false;
        };
        const duraComp = itemStack.getComponent("minecraft:durability");
        if (!duraComp) {
            return false;
        };
        if (damage > duraComp.maxDurability - duraComp.damage) {
            slot.setItem(); /* 0 -> undefined */
        } else {
            duraComp.damage += damage;
            slot.setItem(itemStack);
        };
        return true;
    }

    static decrementStack(slot) {
        slot <= 1 ? slot.setItem() /* 0 -> undefined */ : slot.amount--;
    }
}