import { VERTICAL_SLAB_STATES } from "../data/stateData";
import { VERTICAL_SLABS, DOUBLE_VERTICAL_SLABS } from "../enum/blockList";
import { BlockUtils } from "./blockUtils";

export class VerticalSlabUtils extends BlockUtils {
    static isVerticalSlab(block) {
        return Object.values(VERTICAL_SLABS).some((id) => block.permutation.matches(id));
    }

    static isDoubleVerticalSlab(block) {
        return Object.values(DOUBLE_VERTICAL_SLABS).some((id) => block.permutation.matches(id));
    }

    static getDirection(verticalSlab) {
        return verticalSlab.permutation.getState(VERTICAL_SLAB_STATES[0][0]);
    }

    static verticalSlabToDouble(id) {
        if (Object.values(VERTICAL_SLABS).includes(id)) {
            return id.slice(0, 5) + "double_" + id.slice(5);
        } else {
            return null;
        };
    }

    static doubleToVerticalSlab(id) {
        if (Object.values(DOUBLE_VERTICAL_SLABS).includes(id)) {
            return id.replace("double_", "");
        } else {
            return null;
        };
    }
}