import { world, system } from "@minecraft/server";
import { CopperTransformationType } from "../../../library/enum/system";
import { VerticalSlab } from "../../block/verticalSlab";
import { VerticalSlabSet } from "../../block/verticalSlabSet";

export class CopperUpdateEvents {
    setup() {
        system.afterEvents.scriptEventReceive.subscribe(data => this.#randomTickOxidize(data));
        world.beforeEvents.itemUseOn.subscribe(data => this.#onInteract(data))
    }

    #randomTickOxidize(data) {
        const cutCopperVerticalSlab = new VerticalSlab(data.sourceBlock);
        cutCopperVerticalSlab.transCopper(CopperTransformationType.OXIDIZE);
    }

    #onInteract(data) {
        const update = new VerticalSlabSet(data);
        system.run(() => update.inetractCopper());
    }
}

export const copperUpdate = new CopperUpdateEvents();