import config from "../config";
import { copperUpdate } from "./events/verticalSlab/copperUpdate";
import { verticalSlabBreak } from "./events/verticalSlab/verticalSlabBreak";
import { verticalSlabMerge } from "./events/verticalSlab/verticalSlabMerge";
import { verticalSlabPlace } from "./events/verticalSlab/verticalSlabPlace";
import { verticalSlabWaterlog } from "./events/verticalSlab/verticalSlabWaterlog";

export class Initialize {
    static worldInit() {
        copperUpdate.setup();
        verticalSlabBreak.setup();
        verticalSlabMerge.setup();
        verticalSlabPlace.setup();
        if (config.canWaterlog) {
            verticalSlabWaterlog.setup();
        };
    }
}